<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/initiate_file_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>08/22/83  initiate_file_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>The initiate_file_ subroutine contains entry points for making a
<span id="L4" class="LineNr">  4 </span>segment or archive component known with a null reference name.
<span id="L5" class="LineNr">  5 </span>
<span id="L6" class="LineNr">  6 </span>
<span id="L7" class="LineNr">  7 </span>Entry points in initiate_file_:
<span id="L8" class="LineNr">  8 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L9" class="LineNr">  9 </span>
<span id="L10" class="LineNr"> 10 </span>
<span id="L11" class="LineNr"> 11 </span>:Entry:  initiate_file_:  03/29/82 initiate_file_
<span id="L12" class="LineNr"> 12 </span>
<span id="L13" class="LineNr"> 13 </span>
<span id="L14" class="LineNr"> 14 </span>Function:  The initiate_file_ entry point, given a directory name,
<span id="L15" class="LineNr"> 15 </span>entry name, and access mode, checks that the user's process has at
<span id="L16" class="LineNr"> 16 </span>least the desired access on the specified segment.  If so, the segment
<span id="L17" class="LineNr"> 17 </span>is initiated with a null reference name.  This entry point returns a
<span id="L18" class="LineNr"> 18 </span>pointer to the base of the segment and the bit count of the segment.
<span id="L19" class="LineNr"> 19 </span>
<span id="L20" class="LineNr"> 20 </span>
<span id="L21" class="LineNr"> 21 </span>Syntax:
<span id="L22" class="LineNr"> 22 </span>declare initiate_file_ entry <span class="textRainbow_lv0_p0">(</span>char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> bit <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> pointer<span class="textRainbow_lv0_o0">,</span>
<span id="L23" class="LineNr"> 23 </span>     fixed binary <span class="textRainbow_lv1_p0">(</span>24<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed binary <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L24" class="LineNr"> 24 </span>call initiate_file_ <span class="textRainbow_lv0_p0">(</span>dirname<span class="textRainbow_lv0_o0">,</span> entryname<span class="textRainbow_lv0_o0">,</span> mode<span class="textRainbow_lv0_o0">,</span> seg_ptr<span class="textRainbow_lv0_o0">,</span> bit_count<span class="textRainbow_lv0_o0">,</span>
<span id="L25" class="LineNr"> 25 </span>     code<span class="textRainbow_lv0_p0">)</span>;
<span id="L26" class="LineNr"> 26 </span>
<span id="L27" class="LineNr"> 27 </span>
<span id="L28" class="LineNr"> 28 </span>Arguments:
<span id="L29" class="LineNr"> 29 </span>dirname
<span id="L30" class="LineNr"> 30 </span>   is the pathname of the containing directory.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L31" class="LineNr"> 31 </span>entryname
<span id="L32" class="LineNr"> 32 </span>   is the entryname of the segment.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L33" class="LineNr"> 33 </span>mode
<span id="L34" class="LineNr"> 34 </span>   is the required access mode to the segment.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> The first three
<span id="L35" class="LineNr"> 35 </span>   bits correspond to the modes read, execute, and write.  The
<span id="L36" class="LineNr"> 36 </span>   remaining bits, if any, must be zero.  Named constants for the
<span id="L37" class="LineNr"> 37 </span>   access modes are declared in access_mode_values.incl.pl1.
<span id="L38" class="LineNr"> 38 </span>seg_ptr
<span id="L39" class="LineNr"> 39 </span>   if the segment was made known, this is a pointer to the base of the
<span id="L40" class="LineNr"> 40 </span>   segment.  Otherwise, this is null.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L41" class="LineNr"> 41 </span>
<span id="L42" class="LineNr"> 42 </span>
<span id="L43" class="LineNr"> 43 </span>bit_count
<span id="L44" class="LineNr"> 44 </span>   is the bit count of the segment.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L45" class="LineNr"> 45 </span>code
<span id="L46" class="LineNr"> 46 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>  It may have one of the
<span id="L47" class="LineNr"> 47 </span>   following values:
<span id="L48" class="LineNr"> 48 </span>   error_table_$no_r_permission
<span id="L49" class="LineNr"> 49 </span>        read permission was required but not present
<span id="L50" class="LineNr"> 50 </span>   error_table_$no_e_permission
<span id="L51" class="LineNr"> 51 </span>        execute permission was required but not present
<span id="L52" class="LineNr"> 52 </span>   error_table_$no_w_permission
<span id="L53" class="LineNr"> 53 </span>        write permission was required but not present
<span id="L54" class="LineNr"> 54 </span>
<span id="L55" class="LineNr"> 55 </span>
<span id="L56" class="LineNr"> 56 </span>Notes:  The specified segment must exist, and the user must have
<span id="L57" class="LineNr"> 57 </span>nonnull access to it, as well as the required modes, in order to make
<span id="L58" class="LineNr"> 58 </span>it known.
<span id="L59" class="LineNr"> 59 </span>
<span id="L60" class="LineNr"> 60 </span>If making the segment known encounters the error_table_$segknown status
<span id="L61" class="LineNr"> 61 </span>code, a zero status code is returned instead.  This enables the user of
<span id="L62" class="LineNr"> 62 </span>this entry point to test either the returned pointer, or the status
<span id="L63" class="LineNr"> 63 </span>code, to indicate whether the segment was made known or not.
<span id="L64" class="LineNr"> 64 </span>
<span id="L65" class="LineNr"> 65 </span>The hcs_$terminate_noname entry point or the terminate_file_ subroutine
<span id="L66" class="LineNr"> 66 </span>should be used to make the segment unknown.
<span id="L67" class="LineNr"> 67 </span>
<span id="L68" class="LineNr"> 68 </span>
<span id="L69" class="LineNr"> 69 </span>:Entry:  create:  09/22/86  initiate_file_$create
<span id="L70" class="LineNr"> 70 </span>
<span id="L71" class="LineNr"> 71 </span>
<span id="L72" class="LineNr"> 72 </span>Function:  initiates the specified segment with a null reference
<span id="L73" class="LineNr"> 73 </span>provided that the user's process has at least the desired access to the
<span id="L74" class="LineNr"> 74 </span>segment.  If the segment does not exist, it will be created .
<span id="L75" class="LineNr"> 75 </span>
<span id="L76" class="LineNr"> 76 </span>
<span id="L77" class="LineNr"> 77 </span>Syntax:
<span id="L78" class="LineNr"> 78 </span>dcl  initiate_file_$create entry <span class="textRainbow_lv0_p0">(</span>char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> bit <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> pointer<span class="textRainbow_lv0_o0">,</span>
<span id="L79" class="LineNr"> 79 </span>          bit <span class="textRainbow_lv1_p0">(</span>1<span class="textRainbow_lv1_p0">)</span> aligned<span class="textRainbow_lv0_o0">,</span> fixed binary <span class="textRainbow_lv1_p0">(</span>24<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed binary <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L80" class="LineNr"> 80 </span>call initiate_file_$create <span class="textRainbow_lv0_p0">(</span>dirname<span class="textRainbow_lv0_o0">,</span> entryname<span class="textRainbow_lv0_o0">,</span> mode<span class="textRainbow_lv0_o0">,</span> seg_ptr<span class="textRainbow_lv0_o0">,</span> created<span class="textRainbow_lv0_o0">,</span>
<span id="L81" class="LineNr"> 81 </span>          bit_count<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L82" class="LineNr"> 82 </span>
<span id="L83" class="LineNr"> 83 </span>
<span id="L84" class="LineNr"> 84 </span>Arguments:
<span id="L85" class="LineNr"> 85 </span>dirname
<span id="L86" class="LineNr"> 86 </span>   is the pathname of the containing directory.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L87" class="LineNr"> 87 </span>entryname
<span id="L88" class="LineNr"> 88 </span>   is the entryname of the segment.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L89" class="LineNr"> 89 </span>mode
<span id="L90" class="LineNr"> 90 </span>   is the required access mode to the segment.  The first three bits
<span id="L91" class="LineNr"> 91 </span>   correspond to the modes read, execute, and write.  The remaining
<span id="L92" class="LineNr"> 92 </span>   bits, if any, must be zero.  Named constants for the access modes
<span id="L93" class="LineNr"> 93 </span>   are declared in access_mode_values.incl.pl1.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L94" class="LineNr"> 94 </span>seg_ptr
<span id="L95" class="LineNr"> 95 </span>   is set to a pointer to the base of the segment if successfull;
<span id="L96" class="LineNr"> 96 </span>   otherwise, it is set to null.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L97" class="LineNr"> 97 </span>created
<span id="L98" class="LineNr"> 98 </span>   is set to &quot;1&quot;b if the segment did not exist and was created by this
<span id="L99" class="LineNr"> 99 </span>   call; otherwise, it is set to &quot;0&quot;b.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L100" class="LineNr">100 </span>
<span id="L101" class="LineNr">101 </span>
<span id="L102" class="LineNr">102 </span>bit_count
<span id="L103" class="LineNr">103 </span>   is set to the bit count of the segment.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L104" class="LineNr">104 </span>code
<span id="L105" class="LineNr">105 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>  It may have one of the
<span id="L106" class="LineNr">106 </span>   following values:
<span id="L107" class="LineNr">107 </span>   error_table_$no_m_permission
<span id="L108" class="LineNr">108 </span>        the segment did not exist and could not be created with the
<span id="L109" class="LineNr">109 </span>        required access.
<span id="L110" class="LineNr">110 </span>   error_table_$no_r_permission
<span id="L111" class="LineNr">111 </span>        read permission was required but not present
<span id="L112" class="LineNr">112 </span>   error_table_$no_e_permission
<span id="L113" class="LineNr">113 </span>        execute permission was required but not present
<span id="L114" class="LineNr">114 </span>   error_table_$no_w_permission
<span id="L115" class="LineNr">115 </span>        write permission was required but not present
<span id="L116" class="LineNr">116 </span>
<span id="L117" class="LineNr">117 </span>
<span id="L118" class="LineNr">118 </span>Notes:
<span id="L119" class="LineNr">119 </span>If making the segment known encounters the error_table_$segknown status
<span id="L120" class="LineNr">120 </span>code, a zero status code is returned instead.  This enables the user of
<span id="L121" class="LineNr">121 </span>this entry point to test either the returned pointer, or the status
<span id="L122" class="LineNr">122 </span>code, to indicate whether the segment was made known or not.
<span id="L123" class="LineNr">123 </span>
<span id="L124" class="LineNr">124 </span>The terminate_file_ subroutine should be used to make the segment
<span id="L125" class="LineNr">125 </span>unknown.  If the segment was create by this call and the caller
<span id="L126" class="LineNr">126 </span>terminates abnormally or its cleanup handler is invoked, the caller may
<span id="L127" class="LineNr">127 </span>use the delete option of terminate_file_ to remove the segment that was
<span id="L128" class="LineNr">128 </span>created.
<span id="L129" class="LineNr">129 </span>
<span id="L130" class="LineNr">130 </span>
<span id="L131" class="LineNr">131 </span>:Entry:  component:  03/09/82  initiate_file_$component
<span id="L132" class="LineNr">132 </span>
<span id="L133" class="LineNr">133 </span>
<span id="L134" class="LineNr">134 </span>Function:  This entry point can make either a segment or an archive
<span id="L135" class="LineNr">135 </span>component known with a null reference name.
<span id="L136" class="LineNr">136 </span>
<span id="L137" class="LineNr">137 </span>If the component name is null, this entry point is identical to
<span id="L138" class="LineNr">138 </span>initiate_file_.
<span id="L139" class="LineNr">139 </span>
<span id="L140" class="LineNr">140 </span>Otherwise, the directory name and entry name arguments are assumed to
<span id="L141" class="LineNr">141 </span>specify an achive, and the component name specifies a component within
<span id="L142" class="LineNr">142 </span>that archive.  If the user's process has at least the desired acces on
<span id="L143" class="LineNr">143 </span>the archive segment, and the user desires no more than read access,
<span id="L144" class="LineNr">144 </span>then the archive is made known with a null reference name, and a
<span id="L145" class="LineNr">145 </span>segment number is assigned.  This entry point returns a pointer to the
<span id="L146" class="LineNr">146 </span>base of the component and the bit count of the component.
<span id="L147" class="LineNr">147 </span>
<span id="L148" class="LineNr">148 </span>
<span id="L149" class="LineNr">149 </span>Syntax:
<span id="L150" class="LineNr">150 </span>declare initiate_file_$component entry <span class="textRainbow_lv0_p0">(</span>char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> char <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span>
<span id="L151" class="LineNr">151 </span>     bit <span class="textRainbow_lv1_p0">(</span>*<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> pointer<span class="textRainbow_lv0_o0">,</span> fixed binary <span class="textRainbow_lv1_p0">(</span>24<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed binary <span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L152" class="LineNr">152 </span>call initiate_file_$component <span class="textRainbow_lv0_p0">(</span>dirname<span class="textRainbow_lv0_o0">,</span> entryname<span class="textRainbow_lv0_o0">,</span> component_name<span class="textRainbow_lv0_o0">,</span>
<span id="L153" class="LineNr">153 </span>     mode<span class="textRainbow_lv0_o0">,</span> component_ptr<span class="textRainbow_lv0_o0">,</span> bit_count<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L154" class="LineNr">154 </span>
<span id="L155" class="LineNr">155 </span>
<span id="L156" class="LineNr">156 </span>Arguments:
<span id="L157" class="LineNr">157 </span>dirname
<span id="L158" class="LineNr">158 </span>   is the pathname of the containing directory.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L159" class="LineNr">159 </span>entryname
<span id="L160" class="LineNr">160 </span>   if component_name is null, this is the entryname of the segment.
<span id="L161" class="LineNr">161 </span>   Otherwise, this is the entryname of an archive.  The archive suffix
<span id="L162" class="LineNr">162 </span>   must be supplied.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L163" class="LineNr">163 </span>component_name
<span id="L164" class="LineNr">164 </span>   is null, or is the name of a component in the archive.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L165" class="LineNr">165 </span>mode
<span id="L166" class="LineNr">166 </span>   is the required access mode to the segment.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span> The first three
<span id="L167" class="LineNr">167 </span>   bits correspond to the modes read, execute, and write.  The
<span id="L168" class="LineNr">168 </span>   remaining bits, if any, must be zero.  Named constants for the
<span id="L169" class="LineNr">169 </span>   access modes are declared in access_mode_values.incl.pl1.
<span id="L170" class="LineNr">170 </span>
<span id="L171" class="LineNr">171 </span>
<span id="L172" class="LineNr">172 </span>component_ptr
<span id="L173" class="LineNr">173 </span>   if the segment was made known, this is a pointer to the base of the
<span id="L174" class="LineNr">174 </span>   segment or the base of the archive component.  Otherwise, this is
<span id="L175" class="LineNr">175 </span>   null.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L176" class="LineNr">176 </span>bit_count
<span id="L177" class="LineNr">177 </span>   is the bit count of the segment or archive component.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L178" class="LineNr">178 </span>code
<span id="L179" class="LineNr">179 </span>   is a standard status code.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>  In addition to the above
<span id="L180" class="LineNr">180 </span>   values, it may have:
<span id="L181" class="LineNr">181 </span>   error_table_$archive_component_modification
<span id="L182" class="LineNr">182 </span>        write permission was required on an archive component
<span id="L183" class="LineNr">183 </span>
<span id="L184" class="LineNr">184 </span>
<span id="L185" class="LineNr">185 </span>Notes:  The notes for the initiate_file_ entry point apply to this
<span id="L186" class="LineNr">186 </span>entry point also.
<span id="L187" class="LineNr">187 </span>
<span id="L188" class="LineNr">188 </span>If a nonnull component name is specified, the following constraints
<span id="L189" class="LineNr">189 </span>apply to the use of this entry point:
<span id="L190" class="LineNr">190 </span> <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span> The component may not be modified.  Only read access is permitted.
<span id="L191" class="LineNr">191 </span> <span class="textRainbow_lv0_p0">(</span>2<span class="textRainbow_lv0_p0">)</span> The component is guaranteed to be contiguous and aligned on a word
<span id="L192" class="LineNr">192 </span>     boundary.  It is not guaranteed to have any other alignment.
<span id="L193" class="LineNr">193 </span> <span class="textRainbow_lv0_p0">(</span>3<span class="textRainbow_lv0_p0">)</span> No explicit dependence on the format of archives is permitted.
<span id="L194" class="LineNr">194 </span>     This means that only the data starting at the pointer and
<span id="L195" class="LineNr">195 </span>     extending as far as the bit count may be referenced.  No data
<span id="L196" class="LineNr">196 </span>     before or after the component may be referenced.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
